Check bool.
Print bool.

Check bool_ind.

Definition neg (b : bool) : bool :=
match b with
  true => false
| false => true
end.

Print neg.

Lemma bool1 : forall b : bool, neg (neg b) = b.
intro b.
(* destruct b case b elim b *)
elim b; simpl; reflexivity.
Qed.

Lemma nat1 : forall n : nat, plus n O = n.
induction n.
simpl. 
reflexivity.
simpl. 
rewrite IHn.
reflexivity.
Qed.

Lemma nat2 : forall n : nat, plus O n = n.
simpl.
auto.
Qed.

Print True.
Print False.

Lemma False1 : forall A:Prop, False -> A.
intros A HF.
(* contradiction. *)
elim HF.
Qed.
 
Check False_ind.

Print and.
Print or.

Lemma triv1 :forall A B :Prop, A /\ B -> A\/B.
intros A B.
intro H.
destruct H.
(* induction H. 
case H.
elim H.*)
left.
exact H.
Qed.

Lemma triv2 :forall A B C :Prop, (A->C) \/ (B->C) -> A/\B -> C.
intros A B C H1 H2.
destruct H1.
destruct H2.
apply H; auto.
apply H; auto.
destruct H2.
auto.
Qed.

Lemma triv3 :forall A B C :Prop, (C->A) /\ (C->B) -> C -> A/\B.
intros.
split.
destruct H.
apply (H H0).
destruct H; apply (H1 H0).
Qed.

Definition NAT := forall A:Set, A -> (A->A)->A.
Definition ZERO := fun (A:Set)(x:A)(f:A->A) => x.
Definition SUCC := fun (n:NAT) => fun(A:Set)(x:A)(f:A->A) => 
f(n A x f).

Inductive natlist : Set :=
nil : natlist
| cons : nat -> natlist -> natlist.
 
Definition example_list := cons 1 (cons 2 (cons 3 (cons 4 nil))).

Fixpoint append (l k : natlist) : natlist :=
match l with
nil => k
| cons n l' => cons n (append l' k)
end.

Fixpoint reverse (l : natlist) : natlist :=
match l with
nil => nil
| cons n l' => append (reverse l') (cons n nil)
end.

Lemma app_nil : forall k: natlist, append k nil = k.
induction k.
simpl. auto.
simpl.
rewrite IHk. auto.
Qed.

(* Problem
   We first need to prove the following Lemma *)

Lemma rev_assoc : forall l k m : natlist, append(append l k) m = append l (append k m).
induction l.
intros k m.
simpl.
auto.
intros k m.
simpl.
rewrite IHl.
auto.
Qed.

Lemma rev_app : forall ( k l:natlist), reverse (append k l) = append (reverse l)(reverse k).
intro k.
induction k.
simpl.
intro l.
rewrite app_nil. auto.
intro l.
simpl.
rewrite IHk.
rewrite rev_assoc.
auto.
Qed.




Lemma rev_list : forall l : natlist, reverse (reverse l) = l.
intro l.
induction l.
simpl.
reflexivity.
simpl.
Abort.


Require Import List.

Check list.
Print list.
Check cons.

Definition example_list' := cons 1 (cons 2 (cons 3 (cons 4 nil))).

Print example_list'.

Definition example_list'' := example_list' ++ example_list'.

Eval compute in example_list''.

(* Example of a WRONG Fixpint definition!
Fixpoint f (n : nat) {struct n} : nat :=
match n with
O => O
| S p => f (f p)
end.
*)
